using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace SimpleMirror
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Timer timer1;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(292, 266);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// timer1
			// 
			this.timer1.Enabled = true;
			this.timer1.Interval = 6000;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.pictureBox1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		Collabrary.Camera camera;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			camera = new Collabrary.CameraClass();
			camera.Captured += new Collabrary.CameraEvents_CapturedEventHandler(this.camera_Captured);
			camera.Size = Collabrary.CameraSizeStyle.s320x240;
			camera.FrameRate = 15;
		}

		private void camera_Captured(Collabrary.IPhoto Frame)
		{
			this.pictureBox1.Image = Image.FromHbitmap(Frame.Hbitmap);
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			//
			// The .NET garbage collection framework does not signal COM objects when the form is closed.
			// As a result, it is necessary to manually set the Camera.FrameRate to zero to stop the background
			// capture thread.
			//
			camera.FrameRate = 0;
		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			//
			// This part is optional.
			//
			// COM and .NET do not work together so well.
			// The issue is that the .NET garbage collector is
			// unable to track the many kilobytes of memory
			// consumed during video capture. As a result,
			// references to Collabrary.Photo objects hang
			// around longer than is necessary.
			//
			// One simple workaround is to add a timer to your
			// main form, have it go off periodically (6 to 15 seconds)
			// and in the Timer.Tick event handler, suggest to the
			// garbage collector that it perform a collection.
			//
			// This hack effectively deals with .NET-inspired COM-related "memory leaks".
			//
			GC.Collect();
		}
	}
}
